<?php

/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */


namespace Model;

use Base\BaseModel;
use Handler\DataValidationException;

class FamilyusersModel extends BaseModel
{
    protected $table = "familyusers";

    protected $aliasTable = "fmu";

    protected $primaryKey = "id";
    protected $fillable = ["birthOfDate", "createdAt", "email", "familyId", "firstName", "lastName", "password", "updatedAt"];

    public function joinRelationFamily($alias = "family")
    {
        $this->query->join("family as $alias", "$alias.id", "=", "fmu.familyId");
        return $this;
    }


    public function beforeEnterIntoDatabase()
    {
        if (empty($this->familyId)) {
            throw new DataValidationException("familyId cannot be null");
        }
        if (empty($this->firstName)) {
            throw new DataValidationException("firstName cannot be null");
        }
        if (empty($this->lastName)) {
            throw new DataValidationException("lastName cannot be null");
        }
        if (empty($this->password)) {
            throw new DataValidationException("password cannot be null");
        }
        $Family = (new \Model\FamilyModel)->findById($this->familyId);
        if (empty($Family)) {
            throw new DataValidationException("familyId Invalid Relation ID");
        }
        return $this;
    }
}